#include "asm86.h"
#include "ti86asm.inc"


pause   =  $8100    

_user_int_ram EQU $d2fd

#define PAGE1_BPL1         $3C
#define PAGE1_BPL2         $37

VideoDraw = $f300               ; [1024] virtual screen or video ram
GrayDraw1 = $fc00               ; [1024] dark grayscale plane
GrayDraw2 = $f700               ; [1024] light grayscale plane


.org _asm_exec_ram




    nop
    jp ProgStart
    .dw 1
    .dw title
    .dw ICON

title:
    .db "Alien Force 1.0 Olavi Hartonen",0

ICON:
.db 8,1
.db %00001000
.db %00001000
.db %00001000
.db %00011100
.db %00011100
.db %00101010
.db %01111111
.db %01100011
 

Title:
    ld hl,Layer2               ; point to RLE picture to display
    ld de,$ca00                ; display picture in video memory
    call DispRLE               ; decode and display the picture

    ld hl,Layer1               ; point to RLE picture to display
    ld de,$f700                ; display picture in video memory
    call DispRLE               ; decode and display the picture
 
 
Loop0:

    ld a,$37
    out (0),a

    halt

    ld a,$0A
    out (0),a

    halt
    halt

    ld a,$3C
    out (0),a

    call _get_key
    cp K_EXIT
    jp z,Exit
    cp K_SECOND
    jp z,Finish
    cp K_ENTER
    jp z,Finish
    cp K_MORE
    call z,ShowHighScores

 jp Loop0

Finish:

    ld a,$3C
    out (0),a  ; screen now shows $100*($C0+$3C) = $FC00, normal

 jp backfromtitle

#include "rle.asm"          ; include RLE picture displayer

#include "alien.asm"        ;alkukuva


ProgStart:
    call _clrScrn
    call _runindicoff
    call _flushallmenus        ; close any open menus
    
    
    ld a,(resume)
    cp 1
    jp z,Resume
    
    
    jp Title
backfromtitle:         
       
    
      
    call OpenGray
    call Setup0
    call EnemySetup
    call Setup1
       
    

                
Loop:  

    call _get_key
    cp K_EXIT
    jp z,Exit
    
    cp K_SECOND
    jp z,Fire    
    cp K_PLUS
    jp z,IncContrast
    cp K_MINUS
    jp z,DecContrast
    cp K_MORE                   ;tallenna ja pois pelist
    jp z,SaveGame
    
    cp K_UP               
    jp z,ToUp               
    cp K_RIGHT
    jp z,ToRight
    cp K_DOWN
    jp z,ToDown
    cp K_LEFT
    jp z,ToLeft    
loopvali:    

    call CheckPos               ;miss kohtaa alus on kent. Sallitaanko kntyminen. 
    call MoveShip               ;liikuta alusta oikeaan suuntaan
    call DrawShip               ;piirr alus
    call Bullet                 ;liikuta ja piirr ammus
    call Enemies                ;kaikki vihollisten liikkeet ja trmykset
    call NextLevel?             ;joko vaihdetaan kentt
    call EnemyBullet            ;liikutetaan vihollisen ammusta. Vain yksi ammus voi olla ilmassa.
    call Slow                   ;kentst riippuen hidastetaan
    
   
    
 ld a,(lives)                   ;jos elmi jljell niin hypp Loop 
 cp 0
 jp nz,Loop            
    ;jos ei en elmi niin jatkuu
 call HighScore?                ;tuliko high score

 jp Exit                        ;loppu




Resume:                 ;aloita peli vanhoilla arvoilla
    call OpenGray
    call Setup1_1       ;setup1:dest kydn vain piirto-osio
    jp Loop    


;Tt kutsutaan Enemies:ist kun ei muuten oikein saanu toimimaan
;Pysytt pelin alussa selkeyden vuoksi. Jokaista enemy kutsutaan erikseen kun jos kutsuis Enemiesi,
;niin enemy_slow_count joutuisi olemaan 1. Alussa katotaan onko elmi, ettei pyshdyttisi mys kun uusi peli
;ei en kuitenkaan psisi alkamaan.
Paused:                
    ld a,(lives)
    cp 0
    ret z 
    call Enemy0
    call Enemy1
    call Enemy2
    call Enemy3
    call Enemy4
    call Enemy5
    call DrawShip
    ld hl,$0001
    ld (_penCol),hl
    ld hl,readytext
    call _vputs    
    call Pause
    ld a,0
    ld (pause),a
    call Setup1_2     
 ret


Setup0:   
    ld a,3
    ld (lives),a   
    ld a,0
    ld (draw_level_count),a
    ld (turning_state),a   
    ld (fired),a
    ld (enemy_fired),a
    ld (enemies_turning_count),a       
    ld hl,1
    ld (level),hl
    ld hl,0
    ld (score),hl
 ret


Setup1:    
    
           
    ld hl,0
    ld (enemy_fired),hl  
      
    ld hl,56
    ld (y),hl
    ld hl,120
    ld (x),hl    
    ld hl,3
    ld (direction),hl
    
    ld hl,99                   
    ld (next_turn),hl            ;99 on ei mihinkn  
 
Setup1_1: ;jos alussa resume 1 niin tullaan vain than 
    ld a,1
    ld (pause),a

    call ClearPage    
    call DrawLevel
Setup1_2: 
    
    
 
    ld a,(pause)
    cp 1
  ret z                             ;jos pause on 1 eli peli pyshtyy ennen pelin alkua niin ulos jo tss
  
    ld hl,$0001
    ld (_penCol),hl
    ld hl,titletext
    call _vputs
    
    ld hl,$0030
    ld (_penCol),hl
    ld hl,leveltext
    call _vputs
    
    ld hl,$0055
    ld (_penCol),hl
    ld hl,scoretext
    call _vputs
    
        
    call DisplayScore
    call DisplayLevel
    call DisplayLives   
    
 ret   
 

EnemySetup:
    ld b,8                               ;sivu rivi
    ld a,1
    ld c,24    
    ld (enemy0_location),bc    
    ld (enemy0_direction),a    
    ld c,40
    ld (enemy1_location),bc    
    ld (enemy1_direction),a
    ld c,56
    ld (enemy2_location),bc    
    ld (enemy2_direction),a    
    ld c,8                               ;yl rivi
    ld a,2
    ld b,40
    ld (enemy3_location),bc    
    ld (enemy3_direction),a
    ld b,56
    ld (enemy4_location),bc    
    ld (enemy4_direction),a
    ld b,72
    ld (enemy5_location),bc    
    ld (enemy5_direction),a
 ret



NextLevel?:                               ;jos kaikki kuolleet niin vaihdetaan kentt
    ld a,(enemy0_direction)
    cp 99 
    ret nz
    ld a,(enemy1_direction)
    cp 99 
    ret nz
    ld a,(enemy2_direction)
    cp 99 
    ret nz
    ld a,(enemy3_direction)
    cp 99 
    ret nz
    ld a,(enemy4_direction)
    cp 99 
    ret nz
    ld a,(enemy5_direction)
    cp 99 
    ret nz
    

    ld a,(level)
    inc a
    ld (level),a
    ld a,0
    
    call EnemySetup
    call Setup1
 ret






;///////////////////////////////osumisia///////////////////////////////////////

EnemyBulletToShip:
    ld a,(enemy_fired)                          
    cp 0
    ret z   

    ld de,(enemy_bullet_location)
    ld a,(x)
    ld b,a
    ld a,(y)
    ld c,a
 
        
    ld a,d                          ;ammus ei ole 8*8
    add a,2
    ld d,a
    
    ld a,e
    add a,2
    ld e,a    


    ld a,b  
    cp d
    ret nc
    
    ld a,b
    add a,4              
    cp d    
    ret c

    ld a,c   
    add a,-1                  
    cp e    
    ret nc

    ld a,c                 
    add a,4      
    cp e    
    ret c

        
    ld a,(lives)
    dec a
    ld (lives),a
    call DrawEnemyBullet
    ;call Pause   
       
    ld b,8                             ;ampuneen vihollisen paikka vaihtuu ylreunaan, ettei
    ld c,8                             ;vain olisi aluksen lhtpaikan pll. Yleens ei                 
    ld (temp_location),bc              ;olisikaan, mutta joskus voi olla.
    
    ld a,0
    ld (enemy_fired),a
    
    call Setup1
    
 ret


BulletToEnemy:
    ld a,(fired)                          ;onko ammuttu
    cp 0
    ret z   

    ld de,(bullet_location)
    ld bc,(temp_location)
 
        
    ld a,d                          ;ammus ei ole 8*8
    add a,2
    ld d,a
    
    ld a,e
    add a,2
    ld e,a    

    ld a,b  
    cp d
    ret nc
    
    ld a,b
    add a,6              
    cp d    
    ret c

    ld a,c   
    add a,-1                  
    cp e    
    ret nc

    ld a,c                 
    add a,6      
    cp e    
    ret c

    ld a,99                                 ;jos direction on 99 niin vihollinen on kuollut
    ld (temp_direction),a
    ld a,0
    ld (fired),a
    call EraseBullet
    call EraseEnemy
    ld a,(score)
    inc a
    ld (score),a 
    call DisplayScore     
 ret


ShipToEnemy:
    ld a,(temp_direction)                ;jos direction on 99 niin vihollinen on kuollut
    cp 99
    ret z   
                
    ld a,(x)
    ld d,a
    ld a,(y)
    ld e,a
    ld bc,(temp_location)
 
        
    ld a,d                  ; ei osu muuten kohdalle
    inc a
    ld d,a
    
    ld a,e
    inc a
    ld e,a    

    ld a,b  
    cp d
    ret nc
    
    ld a,b
    add a,6              
    cp d    
    ret c

    ld a,c   
    add a,-1                  
    cp e    
    ret nc

    ld a,c                 
    add a,6      
    cp e    
    ret c

    
    ld a,(lives)                        ;elmt vhenee
    dec a
    ld (lives),a
    
       
    ld b,8                             ;osutun vihollisen paikka vaihtuu ylreunaan, ettei
    ld c,8                             ;vain olisi aluksen lhtpaikan pll. Yleens ei                 
    ld (temp_location),bc              ;olisikaan, mutta joskus voi olla.
    
  
    call Setup1                         ;jotkut arvot alkuperisiksi   
 ret

;/////////////////////////////////////////////////////////////






;;**************Enemy Stuff*******************************************************

Enemies:
    ld a,(slow_count)
    cp 1
    ret nz
Enemies_1: 
    call Enemy0
    call Enemy1
    call Enemy2
    call Enemy3
    call Enemy4
    call Enemy5
    
    call EnemiesTurningCount    
    
    ld a,(pause)             ;readytext ja pause. Kutsutaan tss kun muuten ei oikein saanu toimimaan. 
    cp 1
    call z,Paused
    
 ret
    
Enemy0:  
    ld a,(enemy0_direction)                    ;jos direction on 99 niin vihollinen on kuollut
    cp 99
    ret z

    ld hl,(enemy0_location)\ ld (temp_location),hl          ;temp_location=enemy0_location
    ld a,(enemy0_direction)\ ld (temp_direction),a          ;temp_direction=enemy0_direction
    call EnemyCalls                                         ;kutsutaan EnemyCallia, joka tekee kaikki liikuttamiset ja vastaavat
    ld hl,(temp_location)\ ld (enemy0_location),hl          ;enemy0_location=temp_location
    ld a,(temp_direction)\ ld (enemy0_direction),a          ;enemy0_direction=temp_direction
 ret    
Enemy1:     
    ld a,(enemy1_direction)
    cp 99
    ret z

    ld hl,(enemy1_location)\ ld (temp_location),hl
    ld a,(enemy1_direction)\ ld (temp_direction),a
    call EnemyCalls
    ld hl,(temp_location)\ ld (enemy1_location),hl
    ld a,(temp_direction)\ ld (enemy1_direction),a
 ret    
Enemy2:       
    ld a,(enemy2_direction)
    cp 99
    ret z
 
    ld hl,(enemy2_location)\ ld (temp_location),hl
    ld a,(enemy2_direction)\ ld (temp_direction),a
    call EnemyCalls
    ld hl,(temp_location)\ ld (enemy2_location),hl
    ld a,(temp_direction)\ ld (enemy2_direction),a
 ret    
Enemy3:    
    ld a,(enemy3_direction)
    cp 99
    ret z
        
    ld hl,(enemy3_location)\ ld (temp_location),hl
    ld a,(enemy3_direction)\ ld (temp_direction),a
    call EnemyCalls
    ld hl,(temp_location)\ ld (enemy3_location),hl
    ld a,(temp_direction)\ ld (enemy3_direction),a
 ret   
Enemy4:    
    ld a,(enemy4_direction)
    cp 99
    ret z
        
    ld hl,(enemy4_location)\ ld (temp_location),hl
    ld a,(enemy4_direction)\ ld (temp_direction),a
    call EnemyCalls
    ld hl,(temp_location)\ ld (enemy4_location),hl
    ld a,(temp_direction)\ ld (enemy4_direction),a
 ret
Enemy5:    
    ld a,(enemy5_direction)
    cp 99
    ret z
        
    ld hl,(enemy5_location)\ ld (temp_location),hl
    ld a,(enemy5_direction)\ ld (temp_direction),a
    call EnemyCalls
    ld hl,(temp_location)\ ld (enemy5_location),hl
    ld a,(temp_direction)\ ld (enemy5_direction),a
 ret


EnemyCalls:
    call MoveEnemy
    call DrawEnemy
    call CheckEnemyPos
    call BulletToEnemy    
    call EnemyFire   
    call ShipToEnemy 
    call EnemyBulletToShip
 ret


DrawEnemy:
    ld a,(temp_direction)
    cp 0
    jp z,LoadEnemySPR0
    cp 1
    jp z,LoadEnemySPR1
    cp 2
    jp z,LoadEnemySPR2
    cp 3
    jp z,LoadEnemySPR3
drawenemyvali:
    ld bc,(temp_location)
    call GraySprite
 ret

LoadEnemySPR0:
    ld hl,ENEMY_SPR0
 jp drawenemyvali    
LoadEnemySPR1:
    ld hl,ENEMY_SPR1
 jp drawenemyvali   
LoadEnemySPR2:
    ld hl,ENEMY_SPR2
 jp drawenemyvali   
LoadEnemySPR3:
    ld hl,ENEMY_SPR3
 jp drawenemyvali    


EraseEnemy:
    ld bc,(temp_location)
    ld hl,EMPTY_SPR
    call GraySprite
 ret



MoveEnemy:  

    call EraseEnemy
    
    ld a,(temp_direction)   
    cp 0
    ld bc,(temp_location)
    jp z,MoveEnemyUp
    cp 1
    jp z,MoveEnemyRight
    cp 2
    jp z,MoveEnemyDown
    cp 3   
    jp z,MoveEnemyLeft
endofmoveenemy:    
    ld (temp_location),bc
 ret
 
MoveEnemyUp:
    ld a,c
    cp 9
        jp c,endofmoveenemy 
    dec c           
 jp endofmoveenemy

  
MoveEnemyRight:
    ld a,b
    cp 120
        jp nc,endofmoveenemy
    inc b    
 jp endofmoveenemy   
 
MoveEnemyDown:
    ld a,c
    cp 56
        jp nc,endofmoveenemy
    inc c   
 jp endofmoveenemy     
     
MoveEnemyLeft:
    ld a,b
    cp 9
        jp c,endofmoveenemy
    dec b
 jp endofmoveenemy    

 ret




CheckEnemyPos:  
      
    ld bc,(temp_location)    
    ld a,b              
    ;add a,4
    sra a
    sra a 
    sra a       
    ld d,a
    

    ld a,c                  ;jaetaan jotta vastaisi LEV kohtaa
    ;add a,4
    sra a
    sra a 
    sra a       
    ld e,a
        
    ld hl,LEV                   ;kentt ladataan
    ld a,e                      ;montako kertaa kerrotaan ruudun leveydell
    ld b,a
    ld a,0
checkposloope:                  ;kerrotaan ruudun leveydell
    add a,16
    djnz checkposloope
    ld c,a
    ld a,d                      
    add a,c                     ;listn x
    ld b,a                      ;toteutetaan hl:lle
checkposloop2e:
    inc hl
    djnz checkposloop2e 
    
    ld a,(hl)                   ;otetaan hl a:han 
              
    cp 0                        
    jp z,DontTurnE     
    cp 2
    jp z,EnemyTurning 
    
    jp DontTurnE
    
checkposende:
        ret

DontTurnE:                          
    ld a,0
    ld (turning_state),a
        jp checkposende  
        

EnemyTurning: 
     
    ld bc,(temp_location)   
    sla d
    sla d
    sla d      
    ld a,b
    cp d
    jr nz,DontTurnE                          
         
    sla e
    sla e
    sla e              
    ld a,c   
    cp e  
    jr nz,DontTurnE
                         
    call EnemiesTurningCount
                                                      
    ld a,(enemies_turning_count)
    cp 0
    jp z,EnemyTurnUp
    cp 1
    jp z,EnemyTurnRight
    cp 2
    jp z,EnemyTurnDown
    cp 3
    jp z,EnemyTurnLeft
                                                                                                                                                                                                                   
enemyturningvali:
    
  jp checkposende


EnemyTurnUp:
    ld a,0
    ld (temp_direction),a
 jp enemyturningvali
EnemyTurnRight:
    ld a,1
    ld (temp_direction),a
 jp enemyturningvali
EnemyTurnDown:
    ld a,2
    ld (temp_direction),a
 jp enemyturningvali
EnemyTurnLeft:
    ld a,3
    ld (temp_direction),a
 jp enemyturningvali


    
            
EnemyFire:
    ld a,(enemy_fired)
    cp 1
    ret z
    ld a,(temp_direction)
    cp 99
    ret z
    
    ld bc,(temp_location)   
    ld a,(y)
    cp c
    call z,DoEnemyFire
    ld bc,(temp_location)   
    ld a,(x)
    cp b
    call z,DoEnemyFire
    
 ret   
  
DoEnemyFire:              
    ld a,1
    ld (enemy_fired),a
    ld a,(temp_direction)
    ld (enemy_bullet_direction),a
    ld hl,(temp_location)
    ld (enemy_bullet_location),hl
 ret    


EnemyBullet:
    ld a,(enemy_fired)
    cp 0
    ret z
    
    
    ld a,(slow_count)
    cp 1
    ret nz
    call EraseEnemyBullet
    call MoveEnemyBullet
    ;call DrawEnemyBullet             ;piirretnkin MoveBulletissa, ettei FiredOffin pyyhitty 
                                 ;piirtyisi tss takaisin   
 ret


MoveEnemyBullet:
    ld bc,(enemy_bullet_location)

    ld a,(enemy_bullet_direction)
    cp 0
    jp z,EnemyBulletUp
    cp 1
    jp z,EnemyBulletRight
    cp 2
    jp z,EnemyBulletDown
    cp 3
    jp z,EnemyBulletLeft
moveenemybulletvali:     
 ret
   
EnemyBulletUp:
    ld a,c
    cp 10
    jp c,EnemyFiredOff
    dec c
    dec c
    ld (enemy_bullet_location),bc
    call DrawEnemyBullet
 jp moveenemybulletvali   

EnemyBulletRight:
    ld a,b
    cp 120
    jp nc,EnemyFiredOff
    inc b
    inc b
    ld (enemy_bullet_location),bc
    call DrawEnemyBullet
 jp moveenemybulletvali   
     
EnemyBulletDown:
    ld a,c
    cp 56
    jp nc,EnemyFiredOff
    inc c
    inc c
    ld (enemy_bullet_location),bc
    call DrawEnemyBullet
 jp moveenemybulletvali    

EnemyBulletLeft:
    ld a,b
    cp 10
    jp c,EnemyFiredOff
    dec b
    dec b
    ld (enemy_bullet_location),bc
    call DrawEnemyBullet
 jp moveenemybulletvali   



DrawEnemyBullet:
    ld bc,(enemy_bullet_location)
    ld hl,ENEMY_BULLET
    call GraySprite
 ret

EraseEnemyBullet:
    ld bc,(enemy_bullet_location)
    ld hl,EMPTY_BULLET_SPR
    call GraySprite
 ret

EnemyFiredOff:
    ld a,0
    ld (enemy_fired),a
    call EraseEnemyBullet
    
 jp moveenemybulletvali

;*********************end of enemy stuff*******************************
















CheckPos:         
    ld a,(x)              
    ;add a,4
    sra a
    sra a 
    sra a       
    ld d,a
    

    ld a,(y)                  ;jaetaan jotta vastaisi LEV kohtaa
    ;add a,4
    sra a
    sra a 
    sra a       
    ld e,a
        
    ld hl,LEV                   ;kentt ladataan
    ld a,e                      ;montako kertaa kerrotaan ruudun leveydell
    ld b,a
    ld a,0
checkposloop:                  ;kerrotaan ruudun leveydell
    add a,16
    djnz checkposloop
    ld c,a
    ld a,d                      
    add a,c                     ;listn x
    ld b,a                      ;toteutetaan hl:lle
checkposloop2:
    inc hl
    djnz checkposloop2 
    
    ld a,(hl)                   ;otetaan hl a:han 
              
    cp 0                        
    jp z,DontTurn     
    cp 2
    jp z,AllowTurning 
    
    jp DontTurn
    
checkposend:
        ret

DontTurn:                          
    ld a,0
    ld (turning_state),a
        jp checkposend  
        
;Jos alus on kakkos palikan kohdalla niin tutkitaan onko se tarkalleen oikeassa kohdassa
;alussa jakamalla saatu tulos kerrotaan nyt ja verrataan sit oikeaan x:n  
AllowTurning:    
    sla d
    sla d
    sla d      
    ld a,(x)
    cp d
    jr nz,DontTurn                          
         
    sla e
    sla e
    sla e              
    ld a,(y)   
    cp e  
    jr nz,DontTurn
                                                                  
                                                                                                                                                                                                                                      
    ld a,1
    ld (turning_state),a
       
    ld a,(next_turn)
    cp 99
        jp z,checkposend
    ld (direction),a
    ld a,99
    ld (next_turn),a
    
 jp checkposend
















DrawShip:                   ;piirr oma alus oikeassa suunnassa
    ld a,(direction)        ;mik suunta? eli mik sprite ladataan hl:n
    cp 0
    jp z,LoadSPR0
    cp 1
    jp z,LoadSPR1
    cp 2
    jp z,LoadSPR2
    cp 3
    jp z,LoadSPR3
drawshipvali:               ;spritejen latauksista palataan thn
    ld a,(x)
    ld b,a
    ld a,(y)
    ld c,a   
    call GraySprite
 ret

LoadSPR0:
    ld hl,SHIP_SPR0
 jp drawshipvali
LoadSPR1:
    ld hl,SHIP_SPR1
 jp drawshipvali
LoadSPR2:
    ld hl,SHIP_SPR2
 jp drawshipvali
LoadSPR3:
    ld hl,SHIP_SPR3
 jp drawshipvali


EraseShip:                      ;pyyhi alus
    ld a,(x)
    ld b,a
    ld a,(y)
    ld c,a
    ld hl,EMPTY_SPR
    call GraySprite
 ret


; direction suunnat
 ; 0=ylos
 ; 1=oikealle
 ; 2=alas
 ; 3=vasemmalle

MoveShip:                               ;liikutetaan alusta johonkin suuntaan riippuen mik on direction
    ld a,(slow_count)
    cp 1
    ret nz

    call EraseShip
    
    ld a,(direction)   
    cp 0
    jp z,MoveShipUp
    cp 1
    jp z,MoveShipRight
    cp 2
    jp z,MoveShipDown
    cp 3   
    jp z,MoveShipLeft
endofmoveship:    

 ret
 
MoveShipUp:
    ld a,(y)
    cp 9
        jp c,endofmoveship 
    dec a
    ld (y),a
    cp 10    
 jp endofmoveship 

  
MoveShipRight:
    ld a,(x)
    cp 120
        jp nc,endofmoveship 
    inc a
    ld (x),a
 jp endofmoveship    
 
MoveShipDown:
    ld a,(y)
    cp 56
        jp nc,endofmoveship
    inc a
    ld (y),a
 jp endofmoveship     
     
MoveShipLeft:
    ld a,(x)
    cp 9
        jp c,endofmoveship
    dec a
    ld (x),a
 jp endofmoveship      
           
 

   


                        
ToUp:   
    ld a,(turning_state)
    cp 0                 ;vaihda suunnaksi yls jos on painettu ylos ja ei olla palikan kohdalla
    jr z,OppositeUp
backfromoppositeup:                
    ld a,0                      
    ld (direction),a
 jp loopvali 
ToRight:                ;vaihda suunnaksi oikea "
    ld a,(turning_state)
    cp 0
    jr z,OppositeRight   
backfromoppositeright:    
    ld a,1
    ld (direction),a
 jp loopvali  
ToDown:                ;vaihda suunnaksi alas "
    ld a,(turning_state)
    cp 0
    jr z,OppositeDown    
backfromoppositedown:       
    ld a,2
    ld (direction),a
 jp loopvali 
ToLeft:                ;vaihda suunnaksi vasen "
    ld a,(turning_state)
    cp 0
    jr z,OppositeLeft
backfromoppositeleft:     
    ld a,3
    ld (direction),a
 jp loopvali 


; jos painettu suunta on vastakkainen niin salli kntyminen
OppositeUp:
    ld a,(direction)
    cp 2
   jr nz,NextTurnUp
    ld hl,99                   
    ld (next_turn),hl            ;99 on ei mihinkn    
 jr backfromoppositeup          
OppositeRight:
    ld a,(direction)
    cp 3
   jr nz,NextTurnRight
    ld hl,99                   
    ld (next_turn),hl            ;99 on ei mihinkn    
 jr backfromoppositeright               
OppositeDown:
    ld a,(direction)
    cp 0
   jr nz,NextTurnDown 
    ld hl,99                   
    ld (next_turn),hl            ;99 on ei mihinkn     
 jr backfromoppositedown         
OppositeLeft:
    ld a,(direction)
    cp 1
   jr nz,NextTurnLeft
    ld hl,99                   
    ld (next_turn),hl            ;99 on ei mihinkn    
 jr backfromoppositeleft                     



NextTurnUp:
    ld a,0
    ld (next_turn),a
 jp loopvali
NextTurnRight:
    ld a,1
    ld (next_turn),a
 jp loopvali
NextTurnDown:
    ld a,2
    ld (next_turn),a
 jp loopvali
NextTurnLeft:
    ld a,3
    ld (next_turn),a
 jp loopvali






Fire:
    ld a,(fired)
    cp 1
    jp z,loopvali
    ld a,1
    ld (fired),a
    ld a,(direction)
    ld (bullet_dir),a
    ld a,(x)
    ld b,a
    ld a,(y)
    ld c,a
    ld (bullet_location),bc
 jp loopvali    


Bullet:
    ld a,(fired)
    cp 0
    ret z
    ld a,(slow_count)
    cp 1
    ret nz
    call EraseBullet
    call MoveBullet
    ;call DrawBullet             ;piirretnkin MoveBulletissa, ettei FiredOffin pyyhitty 
                                 ;piirtyisi tss takaisin   
 ret


MoveBullet:
    ld bc,(bullet_location)

    ld a,(bullet_dir)
    cp 0
    jp z,BulletUp
    cp 1
    jp z,BulletRight
    cp 2
    jp z,BulletDown
    cp 3
    jp z,BulletLeft
movebulletvali:     
 ret
   
BulletUp:
    ld a,c
    cp 10
    jp c,FiredOff
    dec c
    dec c
    ld (bullet_location),bc
    call DrawBullet
 jp movebulletvali   

BulletRight:
    ld a,b
    cp 120
    jp nc,FiredOff
    inc b
    inc b
    ld (bullet_location),bc
    call DrawBullet
 jp movebulletvali   
     
BulletDown:
    ld a,c
    cp 56
    jp nc,FiredOff
    inc c
    inc c
    ld (bullet_location),bc
    call DrawBullet
 jp movebulletvali    

BulletLeft:
    ld a,b
    cp 10
    jp c,FiredOff
    dec b
    dec b
    ld (bullet_location),bc
    call DrawBullet
 jp movebulletvali   



DrawBullet:
    ld bc,(bullet_location)
    ld hl,BULLET_SPR
    call GraySprite
 ret

EraseBullet:
    ld bc,(bullet_location)
    ld hl,EMPTY_BULLET_SPR
    call GraySprite
 ret

FiredOff:
    ld a,0
    ld (fired),a
    call EraseBullet
    
 jp movebulletvali












DisplayLives:
    ld a,(lives)
    ld c,16    
    ld b,a   
displaylivesvali:
    ld a,c
    add a,8
    ld c,a    
    push bc
        ld b,1    
        ld a,c
        add a,8
        ld c,a    
        ld hl,MINI_SHIP
        call GraySprite  
    pop bc  
 djnz displaylivesvali
 
 ret

DisplayScore:
    ld hl,0*256+107     
    ld (_penCol),hl     
    ld hl,(score)     
    call DispHL
 ret
                

DisplayLevel:
    ld hl,$0048    
    ld (_penCol),hl
    ld hl,(level)
    call DispHL
 ret



ShowHighScores:
    ld hl,(256*0)+0
    ld (_curRow),hl
    ld hl,highscoretext
    call _puts
    ;***    
    ld hl,(256*5)+2
    ld (_curRow),hl
    ld hl,high1_intials
    call _puts
    
    ld hl,(256*11)+3
    ld (_curRow),hl
    ld hl,(high1)
    call DispHLBig
    ;*
    
    ld hl,(256*5)+4
    ld (_curRow),hl
    ld hl,high2_intials
    call _puts
    
    ld hl,(256*11)+5
    ld (_curRow),hl
    ld hl,(high2)
    call DispHLBig
    ;*
    
    ld hl,(256*5)+6
    ld (_curRow),hl
    ld hl,high3_intials
    call _puts
    
    ld hl,(256*11)+7
    ld (_curRow),hl
    ld hl,(high3)
    call DispHLBig
    ;*
    
    call Pause        

 ret


DispA:
 ld l,a
 ld h,0
DispHL:                 ;Displays HL [By: Matthew Shepcar]
 xor a                  ;Loads 0 into A
 ld de,-1                               ;Loads -1 into DE
 ld (_curRow),de                        ;Loads de into CurRow
 call 4A33h                             ;Calls 4A33h
 dec hl                 ;Decrease it
 jp _vputs                              ;Put on screen and return



DispHLBig:                 ;dipslay 5 digits from hl
 xor a 
 ;ld de,-1
 ;ld (_curRow),de
 call 4A33h
 dec hl
 jp _vputs



;;;;;;;;;onko high score;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HighScore?:    
    ld de,(high3)               ;jos score pienempi kuin huonoin high score niin pois
    inc de                      ;listn yhdell, jotta samakaan tulos ei riitisi
    ld hl,(score)
    call _cphlde
    ret c
    
    call CloseGray
    ld hl,(256*3)+0
    ld (_curRow),hl
    ld hl,yougottext
    call _puts
    
    
    
    ld de,(high2)               ;jos score huonompi kuin toiseksi paras niin aseta kolmanneksi parhaaksi  
    inc de                      ;listn yhdell, jotta samakaan tulos ei riitisi
    ld hl,(score)
    call _cphlde
    jp c,ThirdHighestScore
        
    ld de,(high1)               ;jos score huonompi kuin paras niin aseta toiseksi parhaaksi
    inc de                      ;listn yhdell, jotta samakaan tulos ei riitisi
    ld hl,(score)
    call _cphlde
    jp c,SecondHighestScore    
                       
    jp HighestScore              ;jos ollaan tll asti niin tulos on paras - asetetaan parhaaksi           
    
endofhighscore?:  
    call _clrLCD
    call ShowHighScores
 jp Exit


ThirdHighestScore:
    ld hl,(score)
    ld (high3),hl
    ld hl,high3_intials
    call InputName
 jp endofhighscore?
SecondHighestScore:
    ld hl,(high2)   ;toisena ollut siirtyy kolmanneksi
    ld (high3),hl
    ld hl,high2_intials
    ld de,high3_intials
    ld bc,3
    ldir
    ld hl,(score)
    ld (high2),hl   
    ld hl,high2_intials
    call InputName
 jp endofhighscore?
HighestScore:
    ld hl,(high2)
    ld (high3),hl
    ld hl,high2_intials     ;toisena ollut siirtyy kolmanneksi 
    ld de,high3_intials
    ld bc,3
    ldir
    ld hl,(high1)
    ld (high2),hl
    ld hl,high1_intials     ;ensimmisen ollut siirtyy toiseksi
    ld de,high2_intials
    ld bc,3
    ldir
    ld hl,(score)
    ld (high1),hl
    ld hl,high1_intials
    call InputName
 jp endofhighscore?
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;









Slow:   
    ld a,(level)
    ld b,a
    ld a,105
enemyslowvali:
        sub 20
        cp 10
        jr c,outofenemyslowloop
 djnz enemyslowvali 
outofenemyslowloop:     
    ld b,a      
    ld a,(slow_count)
    inc a
    ld (slow_count),a    
    cp b
    ret nz
    ld a,0
    ld (slow_count),a
        ret

EnemiesTurningCount:
    ld a,(enemies_turning_count)
    inc a
    ld (enemies_turning_count),a    
    cp 8
    ret nz
    ld a,0
    ld (enemies_turning_count),a
        ret



Pause:              
    call    _get_key
    cp 0        
    jp z,Pause
        ret             




;///////////////////// draw level ///////////////////////////

DrawLevel: 
    ld hl,LEV   
    ld a,(draw_level_count)
    push bc
    ld b,a
looppi:
    inc hl
    djnz looppi
    pop bc

    ld a,(hl)
    cp 1
    jp z,on
    cp 0
    jp z,off
    cp 5
    jp z,leftborder
    cp 6
    jp z,upborder
        
    jp off              ;jos muuta ei ole niin sitten tyhj
    
vali:
    ld a,b
    add a,8
    ld b,a
    
    cp 128
    call z,addrivi  

    ld a,(draw_level_count)
    inc a
    ld (draw_level_count),a
    cp 128
    jp nz,DrawLevel
        ret
addrivi:
    ld b,0
    ld a,c
    add a,8
    ld c,a
        ret

off:
    push bc 
    ld hl,EMPTY_SPR
    call GraySprite
    pop bc
    jp vali
on: 
    push bc 
    ld hl,BLOCK
    call GraySprite
    pop bc
    jp vali

leftborder: 
    push bc 
    ld hl,BORDER0
    call GraySprite
    pop bc
    jp vali

upborder: 
    push bc 
    ld hl,BORDER1
    call GraySprite
    pop bc
    jp vali
    

;//////////////////////////////////////////////////////////




Exit:    
    ld a,0
    ld (resume),a  
    call SaveGame1_1        ;ei muuta resumeksi 1 niin kuin SaveGame tekisi
    call SaveHighScores    
    call CloseGray  
    call _clrScrn 
    call _homeup   
 ret















;This is a highly optimized writeback routine for saving high scores and saved games.
;-Jonah Cohen       <ComAsYuAre@aol.com>
SaveHighScores:
    ld hl,_asapvar          ;hl->name of program
    rst 20h             ;copy to OP1
    rst 10h             ;_findsym
    xor a
    ld hl,high_score_start-_asm_exec_ram+4        ;offset
    add hl,de               ;hl=pointer to data in original prog
    adc a,b             ;in case we overlapped pages
    call _set_abs_dest_addr
    xor a                   ;no absolute addressing now
    ld hl,high_score_start            ;get data from here
    call _set_abs_src_addr
    ld hl,high_score_end-high_score_start   ;number of bytes to save
    call _set_mm_num_bytes
    jp _mm_ldir         ;copy data and return



SaveGame:
    ld a,1
    ld (resume),a
SaveGame1_1:       ;jos resumeksi ei haluta 1
    call _clrLCD
    call CloseGray
    ld hl,(256*0)+0
    ld (_curRow),hl
    ld hl,gamesavedtext
    call _puts  

    ld hl,_asapvar          ;hl->name of program
    rst 20h             ;copy to OP1
    rst 10h             ;_findsym
    xor a
    ld hl,data_start-_asm_exec_ram+4        ;offset
    add hl,de               ;hl=pointer to data in original prog
    adc a,b             ;in case we overlapped pages
    call _set_abs_dest_addr
    xor a                   ;no absolute addressing now
    ld hl,data_start            ;get data from here
    call _set_abs_src_addr
    ld hl,data_end-data_start   ;number of bytes to save
    call _set_mm_num_bytes
    jp _mm_ldir         ;



IncContrast:       
    ld a,($C008)     
    inc a                               
    ld ($C008),a    
    out (2),a       
        jp loopvali                

    
DecContrast:
    ld a,1
    ld a,($C008)    
    sbc a,1           
    ld ($C008),a    
    out (2),a      
        jp loopvali                




;from KOLLUMS 2.0 - A Columns clone for the TI-86
;By: Alan Bailey <bailela@charlie.cns.iit.edu>
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
InputName:  
    push hl                 ;hl:ss paikka mihin uusi nimi tallennetaan
    ld b,3                  ;3 initials as counter
    ld hl,$0903             ;place to put first initial
    ld (_curRow),hl         ;right there
    pop hl                  ;hl:ss paikka mihin uusi nimi tallennetaan
InputLoop:
    push bc                 ;save the counter
    push hl                 ;save place to store initials
    ld a,$DF                ;this is ti-ascii for the cursor
    call _putc              ;put the cursor
    ld hl,_curCol           ;this is the after putting the cursor
    dec (hl)                ;put it back to where the cursor is
KeyLoop:
    call _get_key            ;gets the key
    ld c,a                  ;get table value from InputTable
    ld b,0                  ;
    ld hl,InputTable
    add hl,bc               ;by adding the keyvalue to InputTable
    ld a,(hl)               ;and get the value
    or a                    ;if it is zero
    jr z,KeyLoop            ;we still need a key
    pop hl                  ;get the initial address back
    ld (hl),a               ;and load the first initial
    inc hl                  ;and move to the next initial
    call _putc              ;put that initial
    pop bc                  ;counter...
    djnz InputLoop          ;and get all three
    ld de,$FFFF             ;or not, at which point we set up a delay
LoopWait:
    dec de                  ;you've seen this before
    ld a,d
    or e
    jr nz,LoopWait
    ret              
;This is the key table, takes the value from call GET_KEY
;and converts it to this ascii character
InputTable:
    .db 0,0,0,0,0,0,0,0,0,0
    .db 'X','T','O','J','E',0,0
    .db ' ','W','S','N','I','D',0,0
    .db 'Z','V','R','M','H','C',0,0
    .db 'Y','U','Q','L','G','B',0,0,0,0
    .db 'P','K','F','A',0,0,0,0,0,0,0,0,0,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;






;///////////////////////////////////////////////////////////////////7

 
 
 
;=========================================================================
; Sprite routines by David Phillips <david@acz.org>    http://www.acz.org/
;=========================================================================
; All sprites are 8x8 masked sprites
;
;   PutSprite      -- black/white                 (sprite, mask)
;   PutSpriteClip  -- black/white with clipping   (sprite, mask)
;   GraySprite     -- grayscale                   (dark, light, mask)
;   GraySpriteClip -- grayscale with clipping     (dark, light, mask)
;
; in:   hl = pointer to sprite, bc = x,y location
; out:  af, bc, de, hl, ix = trash
; size: 250 bytes
;=========================================================================

;=========================================================================
; in: hl = 8x8 masked sprite, bc = x,y location
;----------------------------grayscale-------------------------------------;

OpenGray:
    res 2,(iy+$23)
    ld hl,IntRoutine
    ld de,_user_int_ram+1
    ld bc,InterruptMemEnd-IntRoutine
    ldir
    ld a,(_user_int_ram+1)
    ld hl,_user_int_ram+($28*1)
    add a,(hl)
    ld hl,_user_int_ram+($28*2)
    add a,(hl)
    ld hl,_user_int_ram+($28*3)
    add a,(hl)
    ld hl,_user_int_ram+($28*4)
    add a,(hl)
    ld hl,_user_int_ram+($28*5)
    add a,(hl)
    ld (_user_int_ram),a
    xor a
    ld (IntCounter), a
    ld (UserCounter), a
    ld de, IntData
    ld hl, SourceIntData
    ld bc, 2
    ldir
    set 2,(iy+$23)
    ret

CloseGray:
    res 2, (iy+$23)
    ld a, $3C
    out (0), a
    call ClearPage
    ret

ClearPage:
    ld hl, (Pages)
    call Clear1024
    ld hl, (Pages+2)
    call Clear1024
    ret
Clear1024:
    ld d, h
    ld e, l
    inc de
    ld (hl), 0
    ld bc, 1024
    ldir
    ret

IntRoutine:
    push af
    ld a,($C1B4)   ;_CXCURAPP
    cp $1D
    jr c,DownLeft_check
    cp $20
    jr nc,DownLeft_check
    jr DownLeft_OK
DownLeft_check:
    in a,($03)
    bit 3,a
    jr z,DownLeft_OK
    res 0,a
    out ($03),a
DownLeft_OK:
    push hl
    in a,(3)
    bit 1,a
    jr z,EndIntRoutine
    ld hl, UserCounter
    inc (hl)
    ld hl, IntData
    ld a,(IntCounter)
    cp 5
    jr z,DisplayLast
    cp 3
    jr c,DisplayBpl1
    jr DisplayBpl2

DisplayBpl1:
    inc a
    ld (IntCounter),a
    ld a, (hl)
    out (0),a
    jr EndIntRoutine

DisplayBpl2:
    inc a
    ld (IntCounter),a
    inc hl
    ld a, (hl)
    out (0),a
    jr EndIntRoutine

DisplayLast:
    ld a, (hl)
    out (0), a
    xor a
    ld (IntCounter),a

EndIntRoutine:
    ld a,(UserCounter)
    cp 41
    jr z,EndIntRoutine2
    pop hl
    pop af
    ret
EndIntRoutine2:
    xor a
    ld (UserCounter),a
    pop hl
    pop af
    ret

InterruptMemEnd:

;--------------------------------------------------------------------------;

GraySprite:
 push hl                            ; push sprite pointer
 pop ix                             ; pop in ix
 call FindAddress                   ; calc address and offset
GraySpriteE:
 push hl                            ; save address offset
 push ix                            ; save sprite pointer
 ld de,GrayDraw1                    ; draw to first gray buffer
 add hl,de                          ; add offset to buffer start
 ld a,16                            ; grayscale sprites are 16 bytes
 ld (RenderSpriteM),a               ; adjust sprite load instruction
 call RenderSprite                  ; draw the sprite
 ld a,8                             ; second sprite is 8 bytes from mask
 ld (RenderSpriteM),a               ; adjust sprite load instruction back
 pop ix                             ; restore sprite pointer
 pop hl                             ; restore address offset
 ld de,GrayDraw2                    ; now draw to second gray buffer
 add hl,de                          ; add offset to second buffer start
 ld de,$0008                        ; sprites are 8 bytes
 add ix,de                          ; advance sprite pointer

; in: hl = address in buffer, c = offset, ix = sprite
RenderSprite:
RenderSpriteCV =$+1
 ld b,8                             ; set row counter to 8 bytes
RenderSpriteL:
 push bc                            ; save row counter and sprite offset
 ld a,(ix+8)                        ; load mask for this row
RenderSpriteM =$-1
 cpl                                ; invert the mask
 ld b,a                             ; save inverted mask
 ld d,(ix)                          ; load sprite byte for this row
 inc ix                             ; advance sprite pointer
 ld a,c                             ; set shift counter to sprite offset
 ld c,$ff                           ; set all bits of right mask byte
 ld e,0                             ; clear right byte of sprite
 or a                               ; is the sprite aligned?
 jr z,RenderSpriteD                 ; then skip shifting it
RenderSpriteS:
 srl d                              ; shift left sprite byte
 rr e                               ; into the right sprite byte
 scf                                ; set carry
 rr b                               ; shift left mask byte
 rr c                               ; into the right mask byte
 dec a                              ; decrease shift counter
 jr nz,RenderSpriteS                ; loop until counter is 0
RenderSpriteD:
RenderSpriteCL =$
 ld a,b                             ; load the left sprite byte
 and (hl)                           ; and it with the screen
 or d                               ; or it with the mask
 ld (hl),a                          ; set screen memory to left byte
 inc hl                             ; increase screen pointer
RenderSpriteCR =$
 ld a,c                             ; load the right sprite byte
 and (hl)                           ; and it with the screen
 or e                               ; or it with the mask
 ld (hl),a                          ; set screen memory to left byte
 ld de,15                           ; next row is 15 bytes ahead
 add hl,de                          ; move screen pointer to next row
 pop bc                             ; restore loop counter and shift mask
 djnz RenderSpriteL                 ; loop for all bytes in sprite
 ret                                ; done drawing the sprite

; in: bc = x,y location
; out: hl = offset of byte, c = offset in video byte
FindAddress:
 ld a,c                             ; get the y coord
 add a,a                            ; multiply by 2
 add a,a                            ; again by 4
 ld l,a                             ; save as low byte
 ld h,0                             ; clear high byte
 add hl,hl                          ; multiply by 8
 add hl,hl                          ; and again by 16
 ld a,b                             ; now get the x coord
 and %11111000                      ; clear lower 3 bits
 rra                                ; divide by 2
 rra                                ; this time by 4
 rra                                ; and finally by 8
 or l                               ; combine with low byte
 ld l,a                             ; save it
 ld a,b                             ; get x coord again
 and %00000111                      ; clear all but last 3 bits
 ld c,a                             ; save sprite offset in c
 ret                                ; return to caller


IntCounter              equ _user_int_ram+InterruptMemEnd-IntRoutine+2
IntData                 equ _user_int_ram+InterruptMemEnd-IntRoutine+3
UserCounter             equ _user_int_ram+InterruptMemEnd-IntRoutine+5

SourceIntData:
.db PAGE1_BPL1, PAGE1_BPL2

Pages:
.dw $FC00, $F700













LEV:
    .db 0,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6
    .db 5,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2
    .db 5,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0
    .db 5,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2
    .db 5,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0
    .db 5,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2
    .db 5,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0
    .db 5,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2
    


SHIP_SPR0:
.db %00001000
.db %00001000
.db %00001000
.db %00011100
.db %00001000
.db %00101010
.db %01111111
.db %01100011
.db %00001000
.db %00001000
.db %00001000
.db %00010100
.db %00010100
.db %00110110
.db %01110111
.db %01110111
.db %00001000
.db %00001000
.db %00001000
.db %00011100
.db %00011100
.db %00111110
.db %01111111
.db %01111111


SHIP_SPR1:
.db %00000000
.db %11000000
.db %11100000
.db %01001000
.db %01111111
.db %01001000
.db %11100000
.db %11000000
.db %00000000
.db %11000000
.db %11100000
.db %11111000
.db %00000111
.db %11111000
.db %11100000
.db %11000000
.db %00000000
.db %11000000
.db %11100000
.db %11111000
.db %11111111
.db %11111000
.db %11100000
.db %11000000

SHIP_SPR2:
.db %11000110
.db %11111110
.db %01010100
.db %00010000
.db %00111000
.db %00010000
.db %00010000
.db %00010000
.db %11101110
.db %11101110
.db %01101100
.db %00101000
.db %00101000
.db %00010000
.db %00010000
.db %00010000
.db %11111110
.db %11111110
.db %01111100
.db %00111000
.db %00111000
.db %00010000
.db %00010000
.db %00010000

SHIP_SPR3:
.db %00000011
.db %00000111
.db %00010010
.db %11111110
.db %00010010
.db %00000111
.db %00000011
.db %00000000
.db %00000011
.db %00000111
.db %00011111
.db %11100000
.db %00011111
.db %00000111
.db %00000011
.db %00000000
.db %00000011
.db %00000111
.db %00011111
.db %11111111
.db %00011111
.db %00000111
.db %00000011
.db %00000000


EMPTY_SPR:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111

BLOCK:
.db %00000000
.db %00000001
.db %00000011
.db %00000011
.db %00000011
.db %00000011
.db %01111111
.db %11111111
.db %11111111
.db %01111111
.db %00111111
.db %00111111
.db %00111111
.db %00111111
.db %00000001
.db %00000000
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %11111111



;BLOCK_vara:
;.db %01011010
;.db %10111101
;.db %01100110
;.db %11000011
;.db %11000011
;.db %01100110
;.db %10111101
;.db %01011010
;.db %00111100
;.db %01100110
;.db %11011011
;.db %10100101
;.db %10100101
;.db %11011011
;.db %01100110
;.db %00111100
;.db %11111111
;.db %11111111
;.db %11111111
;.db %11111111
;.db %11111111
;.db %11111111
;.db %11111111
;.db %11111111

BORDER0:
.db %00000000
.db %00000001
.db %00000111
.db %00000111
.db %00000111
.db %00000111
.db %00000111
.db %00000110
.db %00000011
.db %00000111
.db %00000001
.db %00000001
.db %00000001
.db %00000001
.db %00000001
.db %00000010
.db %00000011
.db %00000111
.db %00000111
.db %00000111
.db %00000111
.db %00000111
.db %00000111
.db %00000110

BORDER1:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %11111100
.db %01111110
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %10000011
.db %01111111
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %11111111
.db %01111111

BULLET_SPR:
.db %00000000
.db %00000000
.db %00001000
.db %00011100
.db %00001000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011100
.db %00011100
.db %00011100
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011100
.db %00011100
.db %00011100
.db %00000000
.db %00000000
.db %00000000

ENEMY_SPR0:
.db %00000000
.db %00000000
.db %00001000
.db %00001000
.db %00101010
.db %00101010
.db %01111111
.db %01100011
.db %00000000
.db %00000000
.db %00001000
.db %00001000
.db %00100010
.db %00010100
.db %01110111
.db %01010101
.db %00000000
.db %00000000
.db %00001000
.db %00001000
.db %00101010
.db %00111110
.db %01111111
.db %01111111

ENEMY_SPR1:
.db %00000000
.db %11000000
.db %11110000
.db %01000000
.db %01111100
.db %01000000
.db %11110000
.db %11000000
.db %00000000
.db %11000000
.db %01010000
.db %11100000
.db %00001100
.db %11100000
.db %01010000
.db %11000000
.db %00000000
.db %11000000
.db %11110000
.db %11100000
.db %11111100
.db %11100000
.db %11110000
.db %11000000

ENEMY_SPR2:
.db %01100011
.db %01111111
.db %00101010
.db %00101010
.db %00001000
.db %00001000
.db %00000000
.db %00000000
.db %01010101
.db %01110111
.db %00010100
.db %00100010
.db %00001000
.db %00001000
.db %00000000
.db %00000000
.db %01111111
.db %01111111
.db %00111110
.db %00101010
.db %00001000
.db %00001000
.db %00000000
.db %00000000

ENEMY_SPR3:
.db %00000011
.db %00001111
.db %00000010
.db %00111110
.db %00000010
.db %00001111
.db %00000011
.db %00000000
.db %00000011
.db %00001010
.db %00000111
.db %00110000
.db %00000111
.db %00001010
.db %00000011
.db %00000000
.db %00000011
.db %00001111
.db %00000111
.db %00111111
.db %00000111
.db %00001111
.db %00000011
.db %00000000

MINI_SHIP:
.db %00000000
.db %01000000
.db %11100000
.db %11100000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01000000
.db %01000000
.db %01000000
.db %10100000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01000000
.db %11100000
.db %11100000
.db %10100000
.db %00000000
.db %00000000
.db %00000000

ENEMY_BULLET:
.db %00000000
.db %00000000
.db %00010100
.db %00001000
.db %00010100
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011100
.db %00011100
.db %00011100
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011100
.db %00011100
.db %00011100
.db %00000000
.db %00000000
.db %00000000

EMPTY_BULLET_SPR:
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00011100
.db %00011100
.db %00011100
.db %00000000
.db %00000000
.db %00000000




data_start:                   ;tst alkaa tallennettava tieto

resume:                 .dw 0 ;palataanko edelliseen peliin vai mennnk alkukuvaan ja nollataan tilanne

x:                      .dw 0;= TEXT+2
y:                      .dw 0;= TEXT+4
direction:              .dw 0;= TEXT+6
bullet_location:        .dw 0;= TEXT+8
fired:                  .dw 0;= TEXT+10
bullet_dir:             .dw 0;= TEXT+12
next_turn:              .dw 0;= TEXT+14 ;jos painettu nuolia niin kntyy tnne sueraavassa risteyksess. 99 on ei mihinkn  
turning_state:          .dw 0;= TEXT+16 ;onko kntyminen mahdollista


draw_level_count:       .dw 0;= TEXT+20 ;DrawLevel kytt
score:                  .dw 0;= TEXT+22
level:                  .dw 0;= TEXT+24
lives:                  .dw 0;= TEXT+26

temp_location:          .dw 0;= TEXT+28 ;vihollisten tiedot laitetaan vlill nihin
temp_direction:         .dw 0;= TEXT+30
enemies_turning_count:  .dw 0;= TEXT+32
slow_count:             .dw 0;= TEXT+34 
enemy0_location:        .dw 0;= TEXT+36
enemy0_direction:       .dw 0;= TEXT+38   ;huom jos direction on 99 niin vihollinen on kuollut
enemy1_location:        .dw 0;= TEXT+40
enemy1_direction:       .dw 0;= TEXT+42 
enemy2_location:        .dw 0;= TEXT+44
enemy2_direction:       .dw 0;= TEXT+46
enemy3_location:        .dw 0;= TEXT+48
enemy3_direction:       .dw 0;= TEXT+50
enemy4_location:        .dw 0;= TEXT+52
enemy4_direction:       .dw 0;= TEXT+54
enemy5_location:        .dw 0;= TEXT+56
enemy5_direction:       .dw 0;= TEXT+58

enemy_bullet_location:  .dw 0;= TEXT+60
enemy_bullet_direction: .dw 0;= TEXT+62
enemy_fired:            .dw 0;= TEXT+64

data_end:               ;thn loppuu tallennettava tieto



titletext;
.db "Alien Force",0

leveltext;
.db "level:",0

scoretext;
.db "score:",0

readytext:
.db "Ready??",0

yougottext:
.db "NEW HIGH SCORE!",0

highscoretext:
.db "**** High Scores ****",0  

gamesavedtext:
.db "Game saved",0

high_score_start:                  
high1:              .dw 30  
high1_intials:      .db "ABC",0                
high2:              .dw 20  
high2_intials:      .db "DEF",0    
high3:              .dw 10   
high3_intials:      .db "GHI",0                              
high_score_end:






.end
